package com.daim.flutter_apm

import androidx.annotation.NonNull
import com.daim.flutter_apm.APMFlutterUtils
import com.moonmiles.apm.configuration.APMConfig
import com.moonmiles.apm.sdk.service.APMUIServicesUser
import com.moonmiles.apmservices.model.APMGifts
import com.moonmiles.apmservices.model.APMUser
import com.moonmiles.apmservices.model.optin.APMOptins
import com.moonmiles.apmservices.net.APMException
import com.moonmiles.apmservices.sdk.gift.APMGiftListListener
import com.moonmiles.apmservices.sdk.gift.APMServicesGift
import com.moonmiles.apmservices.sdk.user.APMUserConnectListener
import com.moonmiles.apmservices.sdk.user.APMUserDeleteListener
import com.moonmiles.apmservices.sdk.user.APMUserLogoutListener
import com.moonmiles.apmservices.sdk.user.APMUserOptinsListener
import com.moonmiles.apmservices.utils.APMStatUtils
import com.moonmiles.apmservices.utils.model.user_properties.APMUserPropertiesUtils
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import java.util.*
import kotlin.collections.HashMap

/** APMConfigModule */
class APMConfigModule : FlutterPlugin, MethodCallHandler {
    private lateinit var channel: MethodChannel

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        channel = MethodChannel(flutterPluginBinding.binaryMessenger, "apm_config_module")
        channel.setMethodCallHandler(this)
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        channel.setMethodCallHandler(null)
    }

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
        val arguments: ArrayList<*>
        if(call.arguments != null) {
            arguments = call.arguments as ArrayList<*>
        }
        else {
            arguments = ArrayList<Any>()
        }

        if (call.method == "APM_BADGE_NATURE_BANNER") {
            APM_BADGE_NATURE_BANNER(arguments, result)
        }
        else if (call.method == "APM_BADGE_NATURE_STICKER") {
            APM_BADGE_NATURE_STICKER(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_DAILY_CHALLENGE") {
            APM_SHOW_CONTROLLER_DAILY_CHALLENGE(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_MY_ACCOUNT") {
            APM_SHOW_CONTROLLER_MY_ACCOUNT(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_EARNS") {
            APM_SHOW_CONTROLLER_EARNS(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_BURNS") {
            APM_SHOW_CONTROLLER_BURNS(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_GIFTS") {
            APM_SHOW_CONTROLLER_GIFTS(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_STATUS") {
            APM_SHOW_CONTROLLER_STATUS(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_PAGE") {
            APM_SHOW_CONTROLLER_PAGE(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_CHALLENGES") {
            APM_SHOW_CONTROLLER_CHALLENGES(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_TROPHIES") {
            APM_SHOW_CONTROLLER_TROPHIES(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_INFOS") {
            APM_SHOW_CONTROLLER_INFOS(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_GIFT") {
            APM_SHOW_CONTROLLER_GIFT(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_BARCODE") {
            APM_SHOW_CONTROLLER_BARCODE(arguments, result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_UNSUBSCRIBE") {
            APM_SHOW_CONTROLLER_UNSUBSCRIBE(arguments, result)
        }
        else {
            result.notImplemented()
        }
    }

    private fun APM_BADGE_NATURE_BANNER(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_BADGE_NATURE_BANNER)
    }

    private fun APM_BADGE_NATURE_STICKER(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_BADGE_NATURE_STICKER)
    }

    private fun APM_SHOW_CONTROLLER_DAILY_CHALLENGE(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_DAILY_CHALLENGE)
    }

    private fun APM_SHOW_CONTROLLER_MY_ACCOUNT(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_MY_ACCOUNT)
    }

    private fun APM_SHOW_CONTROLLER_EARNS(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_EARNS)
    }

    private fun APM_SHOW_CONTROLLER_BURNS(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_BURNS)
    }

    private fun APM_SHOW_CONTROLLER_GIFTS(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_GIFTS)
    }

    private fun APM_SHOW_CONTROLLER_STATUS(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_STATUS)
    }

    private fun APM_SHOW_CONTROLLER_PAGE(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_PAGE)
    }

    private fun APM_SHOW_CONTROLLER_CHALLENGES(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_CHALLENGES)
    }

    private fun APM_SHOW_CONTROLLER_TROPHIES(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_TROPHIES)
    }

    private fun APM_SHOW_CONTROLLER_INFOS(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_INFOS)
    }

    private fun APM_SHOW_CONTROLLER_GIFT(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_GIFT)
    }

    private fun APM_SHOW_CONTROLLER_BARCODE(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_BARCODE)
    }

    private fun APM_SHOW_CONTROLLER_UNSUBSCRIBE(arguments: ArrayList<*>, result: Result) {
        result.success(APMConfig.APM_SHOW_CONTROLLER_UNSUBSCRIBE)
    }
}
