package com.daim.flutter_apm

import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin

/** APMPlugin */
class APMPlugin: FlutterPlugin {
  private lateinit var apmModule : APMModule
  private lateinit var apmUiServicesUserModule: APMUIServicesUserModule
  private lateinit var apmServicesGiftModule: APMServicesGiftModule
  private lateinit var apmUserPropertiesUtilsModule: APMUserPropertiesUtilsModule
  private lateinit var apmStatUtilsModule: APMStatUtilsModule
  private lateinit var apmConfigModule: APMConfigModule
  private lateinit var apmDeeplinkUtilsModule: APMDeeplinkUtilsModule


  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    //APMModule
    apmModule = APMModule()
    apmModule.onAttachedToEngine(flutterPluginBinding)

    //APMUIServicesUserModule
    apmUiServicesUserModule = APMUIServicesUserModule()
    apmUiServicesUserModule.onAttachedToEngine(flutterPluginBinding)

    //APMServicesGiftModule
    apmServicesGiftModule = APMServicesGiftModule()
    apmServicesGiftModule.onAttachedToEngine(flutterPluginBinding)

    //APMUserPropertiesUtilsModule
    apmUserPropertiesUtilsModule = APMUserPropertiesUtilsModule()
    apmUserPropertiesUtilsModule.onAttachedToEngine(flutterPluginBinding)

    //APMStatUtilsModule
    apmStatUtilsModule = APMStatUtilsModule()
    apmStatUtilsModule.onAttachedToEngine(flutterPluginBinding)

    //APMConfigModule
    apmConfigModule = APMConfigModule()
    apmConfigModule.onAttachedToEngine(flutterPluginBinding)

    //APMDeeplinkUtilsModule
    apmDeeplinkUtilsModule = APMDeeplinkUtilsModule()
    apmDeeplinkUtilsModule.onAttachedToEngine(flutterPluginBinding)
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    apmModule.onDetachedFromEngine(binding) //APMModule
    apmUiServicesUserModule.onDetachedFromEngine(binding) //APMUIServicesUserModule
    apmServicesGiftModule.onDetachedFromEngine(binding) //APMServicesGiftModule
    apmStatUtilsModule.onDetachedFromEngine(binding) //APMUserPropertiesUtilsModule
    apmStatUtilsModule.onDetachedFromEngine(binding) //APMStatUtilsModule
    apmConfigModule.onDetachedFromEngine(binding) //APMConfigModule
    apmDeeplinkUtilsModule.onDetachedFromEngine(binding) //APMDeeplinkUtilsModule
  }
}
