package com.daim.flutter_apm

import androidx.annotation.NonNull
import com.daim.flutter_apm.APMFlutterUtils
import com.moonmiles.apm.sdk.service.APMUIServicesUser
import com.moonmiles.apmservices.model.APMGifts
import com.moonmiles.apmservices.model.APMUser
import com.moonmiles.apmservices.net.APMException
import com.moonmiles.apmservices.sdk.gift.APMGiftListListener
import com.moonmiles.apmservices.sdk.gift.APMServicesGift
import com.moonmiles.apmservices.sdk.user.APMUserConnectListener
import com.moonmiles.apmservices.sdk.user.APMUserDeleteListener
import com.moonmiles.apmservices.sdk.user.APMUserLogoutListener
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import java.util.*
import kotlin.collections.HashMap

/** APMServicesGiftModule */
class APMServicesGiftModule : FlutterPlugin, MethodCallHandler {
    private lateinit var channel: MethodChannel

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        channel = MethodChannel(flutterPluginBinding.binaryMessenger, "apm_services_gift_module")
        channel.setMethodCallHandler(this)
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        channel.setMethodCallHandler(null)
    }

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
        val arguments: ArrayList<*>
        if(call.arguments != null) {
            arguments = call.arguments as ArrayList<*>
        }
        else {
            arguments = ArrayList<Any>()
        }

        if (call.method == "giftList") {
            giftList(arguments, result)
        }
        else {
            result.notImplemented()
        }
    }

    private fun giftList(arguments: ArrayList<*>, result: Result) {
        val categoryId: String = arguments[0] as String
        val amount: String = arguments[1] as String
        val from: Int = arguments[2] as Int

        APMServicesGift.giftList(categoryId, amount, from, object : APMGiftListListener {
            override fun giftListSuccess(gifts: APMGifts?) {
                APMFlutterUtils.resolveResult(gifts, result)
            }

            override fun failure(exception: APMException?) {
                APMFlutterUtils.rejectResult(exception, result)
            }
        })
    }
}
