package com.daim.flutter_apm

import androidx.annotation.NonNull
import com.daim.flutter_apm.APMFlutterUtils
import com.moonmiles.apm.sdk.service.APMUIServicesUser
import com.moonmiles.apmservices.model.APMGifts
import com.moonmiles.apmservices.model.APMUser
import com.moonmiles.apmservices.net.APMException
import com.moonmiles.apmservices.sdk.gift.APMGiftListListener
import com.moonmiles.apmservices.sdk.gift.APMServicesGift
import com.moonmiles.apmservices.sdk.user.APMUserConnectListener
import com.moonmiles.apmservices.sdk.user.APMUserDeleteListener
import com.moonmiles.apmservices.sdk.user.APMUserLogoutListener
import com.moonmiles.apmservices.utils.model.user_properties.APMUserPropertiesUtils
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import java.util.*
import kotlin.collections.HashMap

/** APMUserPropertiesUtilsModule */
class APMUserPropertiesUtilsModule : FlutterPlugin, MethodCallHandler {
    private lateinit var channel: MethodChannel

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        channel = MethodChannel(flutterPluginBinding.binaryMessenger, "apm_user_properties_utils_module")
        channel.setMethodCallHandler(this)
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        channel.setMethodCallHandler(null)
    }

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
        val arguments: ArrayList<*>
        if(call.arguments != null) {
            arguments = call.arguments as ArrayList<*>
        }
        else {
            arguments = ArrayList<Any>()
        }

        if (call.method == "addUserProperties") {
            addUserProperties(arguments, result)
        }
        else if (call.method == "addUserProperty") {
            addUserProperty(arguments, result)
        }
        else if (call.method == "removeUserProperty") {
            removeUserProperty(arguments, result)
        }
        else if (call.method == "removeUserProperties") {
            removeUserProperties(arguments, result)
        }
        else {
            result.notImplemented()
        }
    }

    private fun addUserProperties(arguments: ArrayList<*>, result: Result) {
        APMUserPropertiesUtils.getInstance().addUserProperties(arguments[0] as HashMap<*, *>)
        result.success(null)
    }

    private fun addUserProperty(arguments: ArrayList<*>, result: Result) {
        APMUserPropertiesUtils.getInstance().addUserProperty(arguments[0] as String?, arguments[1] as String?)
        result.success(null)
    }

    private fun removeUserProperty(arguments: ArrayList<*>, result: Result) {
        APMUserPropertiesUtils.getInstance().removeUserProperty(arguments[0] as String?)
        result.success(null)
    }

    private fun removeUserProperties(arguments: ArrayList<*>, result: Result) {
        APMUserPropertiesUtils.getInstance().removeUserProperties()
        result.success(null)
    }
}
