// Copyright 2018 The Flutter team. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

import 'package:flutter/material.dart';
import 'package:flutter_apm_example/screens/first_screen.dart';
import 'package:flutter_apm_example/utils/apm_utils.dart';
import 'package:flutter_apm/apm_navigator_observer.dart';

void main() {
  return runApp(MyApp());
}

APMNavigatorObserver<PageRoute> apmObserver = APMNavigatorObserver<PageRoute>();

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    APMUtils.initSDKAPM();
    return MaterialApp(
      title: 'Startup Name Generator',
      home: FirstScreen(),
      navigatorObservers: [apmObserver],
    );
  }
}