import Flutter
import UIKit
import APM

public class APMServicesGiftModule: NSObject, FlutterPlugin {
    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = APMServicesGiftModule()
        let channel = FlutterMethodChannel(name: "apm_services_gift_module", binaryMessenger: registrar.messenger())
        registrar.addMethodCallDelegate(instance, channel: channel)
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        let arguments: [Any] = (call.arguments ?? []) as! [Any]
        
        if (call.method == "giftList") {
            giftList(arguments: arguments, result: result)
        }
        else {
            result(FlutterMethodNotImplemented)
        }
    }

    private func giftList(arguments: [Any], result: @escaping FlutterResult) {
        let categoryId: String = arguments[0] as! String
        let amount: String = arguments[1] as! String
        let from: Int = arguments[2] as! Int
        
        APMServicesGift.giftList(categoryId, amount: amount, from: from) { (gifts: NSMutableArray?) in
            APMFlutterUtils.resolveResult(object: gifts, result: result)
        } failure: { (error: Error?) in
            APMFlutterUtils.rejectResultWithError(error: error! as NSError, result: result)
        }
    }
}
