import Flutter
import UIKit
import APM

public class APMUserPropertiesUtilsModule: NSObject, FlutterPlugin {
    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = APMUserPropertiesUtilsModule()
        let channel = FlutterMethodChannel(name: "apm_user_properties_utils_module", binaryMessenger: registrar.messenger())
        registrar.addMethodCallDelegate(instance, channel: channel)
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        let arguments: [Any] = (call.arguments ?? []) as! [Any]
        
        if (call.method == "addUserProperties") {
            addUserProperties(arguments: arguments, result: result)
        }
        else if (call.method == "addUserProperty") {
            addUserProperty(arguments: arguments, result: result)
        }
        else if (call.method == "removeUserProperty") {
            removeUserProperty(arguments: arguments, result: result)
        }
        else if (call.method == "removeUserProperties") {
            removeUserProperties(arguments: arguments, result: result)
        }
        else {
            result(FlutterMethodNotImplemented)
        }
    }

    private func addUserProperties(arguments: [Any], result: FlutterResult) {
        APMUserPropertiesUtils.sharedInstance()?.addUserProperties(arguments[0] as? [AnyHashable : Any])
        result(nil)
    }
    
    private func addUserProperty(arguments: [Any], result: FlutterResult) {
        APMUserPropertiesUtils.sharedInstance()?.addUserProperty(arguments[0] as? String, forKey: arguments[1] as? String)
        result(nil)
    }
    
    private func removeUserProperty(arguments: [Any], result: FlutterResult) {
        APMUserPropertiesUtils.sharedInstance()?.removeUserProperty(arguments[0] as? String)
        result(nil)
    }
    
    private func removeUserProperties(arguments: [Any], result: FlutterResult) {
        APMUserPropertiesUtils.sharedInstance()?.removeUserProperties()
        result(nil)
    }
}
