
import 'dart:async';

import 'package:flutter/services.dart';

class APMUIServicesUserModule {
  static const MethodChannel _channel = const MethodChannel('apm_ui_services_user_module');

  static Future<Map?> userClientConnectWithJSON(Map user) async {
    return await _channel.invokeMethod('userClientConnectWithJSON', [user]);
  }

  static Future<Map?> userClientConnect(String? firstname, String? lastname, String? email, String? facebookId, String? partnerClientId, String? oldClientId, Map? segments, int optIn) async {
    return await _channel.invokeMethod('userClientConnect', [firstname, lastname, email, facebookId, partnerClientId, oldClientId, segments, optIn]);
  }

  static Future userLogout() async {
    await _channel.invokeMethod('userLogout');
  }

  static Future userDelete() async {
    await _channel.invokeMethod('userDelete');
  }
}
